> ## Documentation Index
> Fetch the complete documentation index at: https://composio-preview.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Execute proxy request

> Proxy an HTTP request to a third-party API using connected account credentials. This endpoint allows making authenticated API calls to external services while abstracting away authentication details.



## OpenAPI

````yaml /api-reference/openapi-v3.json post /api/v3/tools/execute/proxy
openapi: 3.0.0
info:
  version: 3.0.0
  title: Composio Platform API
  description: >-
    Composio v3 API — legacy endpoints under /api/v3/. Use v3.1 for new
    integrations.
  contact:
    name: Composio Support
    url: https://composio.dev/support
    email: support@composio.dev
  license:
    name: Proprietary
    url: https://composio.dev/terms
servers:
  - url: https://backend.composio.dev
    description: Composio production API
security:
  - ApiKeyAuth: []
tags:
  - name: Authentication
    description: Authentication related endpoints
    x-group: Authentication
  - name: Auth Configs
    description: Authentication configuration management
    x-group: Auth Configs
  - name: Connected Accounts
    description: Connected account management
    x-group: Connected Accounts
  - name: Logs
    description: Logging and monitoring
    x-group: Logs
  - name: OpenAPI
    description: OpenAPI specification management
    x-group: OpenAPI
  - name: Organization
    description: Organization management
    x-group: Organization
  - name: API Keys
    description: API key management
    x-group: API Keys
  - name: Webhooks
    description: Webhook configuration
    x-group: Webhooks
  - name: Webhook Endpoints
    description: >-
      Per-OAuth-app webhook ingress endpoints. Inbound URLs the provider posts
      to, plus signing secret storage and verification.
    x-group: Webhook Endpoints
  - name: Webhook Subscriptions
    description: >-
      Webhook delivery subscriptions. Outbound URLs Composio posts trigger
      events to, plus signing secret rotation and event-type filters.
    x-group: Webhook Subscriptions
  - name: Team
    description: Team member management
    x-group: Team
  - name: Consumer Skills
    description: Organization-authored Skill management
    x-group: Consumer Skills
  - name: Toolkits
    description: Toolkit and tool management
    x-group: Toolkits
  - name: Tools
    description: Tool execution endpoints
    x-group: Tools
  - name: Triggers
    description: Trigger management and execution
    x-group: Triggers
  - name: Payments
    description: Payment and subscription management
    x-group: Payments
  - name: Billing
    description: Dashboard billing state — usage, subscription, contract (cookie-auth only)
    x-group: Billing
  - name: Compliance
    description: Organization compliance agreements and acceptance state
    x-group: Compliance
  - name: Files
    description: File management
    x-group: Files
  - name: MCP
    description: MCP server management
    x-group: MCP
  - name: MCP Partner
    description: MCP partner management
    x-group: MCP Partner
  - name: Stripe Projects
    description: Stripe Projects provisioning
    x-group: Stripe Projects
  - name: Tool Router
    description: (Labs) Tool router endpoints
    x-group: Sessions (Prev Tool Router)
  - name: Playground
    description: Dashboard playground chat
    x-group: Playground
  - name: Arena
    description: Arena conversations, messages and terms
    x-group: Arena
  - name: Organization Management
    description: Organization Management API endpoints.
    x-group: Organization Management
  - name: Projects
    description: Projects API endpoints.
    x-group: Projects
paths:
  /api/v3/tools/execute/proxy:
    post:
      tags:
        - Tools
      summary: Execute proxy request
      description: >-
        Proxy an HTTP request to a third-party API using connected account
        credentials. This endpoint allows making authenticated API calls to
        external services while abstracting away authentication details.
      operationId: postToolsExecuteProxy
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                connected_account_id:
                  type: string
                  format: connectedAccountId
                  description: >-
                    The ID of the connected account to use for authentication
                    (if not provided, will use the default account for the
                    project)
                  example: ca_1a2b3c4d5e6f
                user_id:
                  type: string
                  description: >-
                    The user id (entity id) acting on connected_account_id.
                    Required for a SHARED connection, where it is checked
                    against the connection's ACL. When the project has 2FA
                    enabled, it is also validated against the owner of a PRIVATE
                    connection. Also selects which custom toolkits the request
                    may use.
                  example: user_4567
                endpoint:
                  type: string
                  description: >-
                    The API endpoint to call (absolute URL or path relative to
                    base URL of the connected account)
                  example: /api/v1/resources
                method:
                  type: string
                  enum:
                    - GET
                    - POST
                    - PUT
                    - DELETE
                    - PATCH
                    - HEAD
                  description: The HTTP method to use for the request
                  example: GET
                body:
                  nullable: true
                  description: The request body (for POST, PUT, and PATCH requests)
                  example:
                    name: New Resource
                    description: This is a new resource
                  type: object
                binary_body:
                  anyOf:
                    - type: object
                      properties:
                        url:
                          type: string
                          format: uri
                          description: URL to fetch binary content from
                        content_type:
                          type: string
                          description: Content-Type header to use for the request
                      required:
                        - url
                    - type: object
                      properties:
                        base64:
                          type: string
                          minLength: 1
                          description: Base64-encoded binary data
                        content_type:
                          type: string
                          description: Content-Type header to use for the request
                      required:
                        - base64
                  description: >-
                    Binary body to send. For binary upload via URL: use {url:
                    "https://...", content_type?: "..."}. For binary upload via
                    base64: use {base64: "...", content_type?: "..."}.
                parameters:
                  type: array
                  items:
                    type: object
                    properties:
                      name:
                        type: string
                        description: Parameter name
                        example: x-api-key
                      value:
                        type: string
                        description: Parameter value
                        example: abc123def456
                      type:
                        type: string
                        enum:
                          - header
                          - query
                        description: Parameter type (header or query)
                        example: header
                    required:
                      - name
                      - value
                      - type
                  description: >-
                    Additional HTTP headers or query parameters to include in
                    the request
                  example:
                    - name: x-api-key
                      value: abc123def456
                      type: header
                    - name: filter
                      value: active
                      type: query
                custom_connection_data:
                  deprecated: true
                  type: object
                  properties:
                    authScheme:
                      type: string
                      enum:
                        - OAUTH2
                        - DCR_OAUTH
                        - API_KEY
                        - BASIC_WITH_JWT
                        - BASIC
                        - BEARER_TOKEN
                        - OAUTH1
                        - NO_AUTH
                        - SERVICE_ACCOUNT
                        - GOOGLE_SERVICE_ACCOUNT
                        - S2S_OAUTH2
                    toolkitSlug:
                      type: string
                    val:
                      type: object
                      properties:
                        subdomain:
                          type: string
                        your-domain:
                          type: string
                        region:
                          type: string
                        shop:
                          type: string
                        account_url:
                          type: string
                        COMPANYDOMAIN:
                          type: string
                        extension:
                          type: string
                        form_api_base_url:
                          type: string
                        instanceEndpoint:
                          type: string
                        api_url:
                          type: string
                        borneo_dashboard_url:
                          type: string
                        proxy_username:
                          type: string
                        proxy_password:
                          type: string
                        domain:
                          type: string
                        version:
                          type: string
                        dc:
                          type: string
                        site_name:
                          type: string
                        instanceName:
                          type: string
                        account_id:
                          type: string
                        your_server:
                          type: string
                        server_location:
                          type: string
                        base_url:
                          type: string
                        displayName:
                          type: string
                        state_prefix:
                          type: string
                          maxLength: 40
                          description: The oauth2 state prefix for the connection
                        long_redirect_url:
                          type: boolean
                          description: >-
                            Whether to return the redirect url without
                            shortening
                        access_token:
                          type: string
                        id_token:
                          type: string
                          nullable: true
                        token_type:
                          type: string
                        refresh_token:
                          type: string
                          nullable: true
                        expires_in:
                          anyOf:
                            - type: number
                            - type: string
                            - nullable: true
                              type: object
                        scope:
                          anyOf:
                            - type: string
                            - type: array
                              items:
                                type: string
                            - nullable: true
                              type: object
                        webhook_signature:
                          type: string
                        authed_user:
                          type: object
                          properties:
                            access_token:
                              type: string
                            scope:
                              type: string
                          description: for slack user scopes
                        extra_token_data:
                          type: object
                          additionalProperties: {}
                        client_id:
                          type: string
                          description: Dynamically registered client ID
                        client_secret:
                          type: string
                          description: Dynamically registered client secret
                        client_id_issued_at:
                          type: number
                        client_secret_expires_at:
                          type: number
                        generic_api_key:
                          type: string
                        api_key:
                          type: string
                        bearer_token:
                          type: string
                        basic_encoded:
                          type: string
                        username:
                          type: string
                        password:
                          type: string
                        token:
                          type: string
                        oauth_token:
                          type: string
                        oauth_token_secret:
                          type: string
                        oauth_verifier:
                          type: string
                        consumer_key:
                          type: string
                        redirectUrl:
                          type: string
                        callback_url:
                          type: string
                        application_id:
                          type: string
                        installation_id:
                          type: string
                        private_key:
                          type: string
                        credentials_json:
                          type: string
                        expires_at:
                          type: string
                      required:
                        - access_token
                      additionalProperties: {}
                  additionalProperties: true
                  required:
                    - authScheme
                    - toolkitSlug
                    - val
              required:
                - endpoint
                - method
      responses:
        '200':
          description: Successfully executed proxy request and received response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    nullable: true
                    description: The response data returned from the proxied API
                    example:
                      id: '123'
                      name: Resource Name
                      created_at: '2023-01-01T00:00:00Z'
                    type: object
                  binary_data:
                    type: object
                    properties:
                      url:
                        type: string
                        description: URL to download binary content
                      content_type:
                        type: string
                        description: Content-Type of the binary data
                      size:
                        type: number
                        description: File size in bytes
                      expires_at:
                        type: string
                        description: ISO 8601 timestamp when the URL expires
                    required:
                      - url
                      - content_type
                      - size
                    description: >-
                      Binary body response data. Present when the response is a
                      binary file.
                  status:
                    type: number
                    description: The HTTP status code returned from the proxied API
                    example: 200
                  headers:
                    type: object
                    additionalProperties:
                      type: string
                    description: The HTTP headers returned from the proxied API
                    example:
                      content-type: application/json
                      cache-control: no-cache
                      host: api.example.com
                required:
                  - status
        '400':
          description: >-
            Bad request - Invalid request parameters or body format, or user_id
            missing or not the owner of connected_account_id on a project with
            2FA enabled
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '401':
          description: Unauthorized - Authentication credentials are missing or invalid
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '403':
          description: >-
            Forbidden - Connected account does not have permission to access the
            requested resource, or user_id is not allowed to use the shared
            connected account
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '404':
          description: Not found - Resource not found or connected account not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '422':
          description: Unprocessable entity - Invalid state of the connected account
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '429':
          description: >-
            Too many requests - Rate limit exceeded on the connected account or
            proxy service
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal server error - Something went wrong on the server
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '501':
          description: >-
            Not implemented - This operation is not supported for the requested
            connected account or authentication scheme
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
      security:
        - ApiKeyAuth: []
components:
  schemas:
    Error:
      type: object
      properties:
        error:
          type: object
          properties:
            message:
              type: string
            code:
              type: number
            slug:
              type: string
            status:
              type: number
            request_id:
              type: string
            suggested_fix:
              type: string
            errors:
              type: array
              items:
                type: string
          required:
            - message
            - code
            - slug
            - status
      required:
        - error
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Composio project API key. Create or copy it from the Composio
        dashboard.
      x-default: your-project-api-key

````